  CLS RGB(42,117,198) 'background colour for display
  'display has 16:9 aspect ratio
  Option explicit ' makes sure every label is assigned properly
  Dim As integer a(1000)  'array a
  Dim As integer b(1000)  'array b
  Dim As integer c(16000) 'array c - this needs a large buffer because of the amount of data to be parsed
  DIM STRING q=Chr$(34) '" symbol
  Open "COM1:9600" As #1 'open com port 1 as #1    'input from pms5003 sensor
  Open "COM2:1200" As #2 'open com port 2 as #2    'send data via hc12 module
  DIM Integer i,j
  DIM cond1$,icon1$,thigh1$,tlow1$,precpr1$,precpicon1$,preciptype1$,thighColour1$,tlowColour1$,temphigh$
  DIM cond2$,icon2$,thigh2$,tlow2$,precpr2$,precpicon2$,preciptype2$,thighColour2$,tlowColour2$,tempnow$
  DIM cond3$,icon3$,thigh3$,tlow3$,precpr3$,precpicon3$,preciptype3$,thighColour3$,tlowColour3$,th$,tempnow1$
  DIM cond4$,icon4$,thigh4$,tlow4$,precpr4$,precpicon4$,preciptype4$,thighColour4$,tlowColour4$,tl$,templow$
  DIM AirObs$,SkyObs$,wind$,direction$,windir$,temp1$,battery1$,battery2$,press1$,uvnow$,sec1$,uvnow1$
  DIM conditions$,icon$,air_temperature$,sea_level_pressure$,station_pressure$,pressure_trend$,time2$
  DIM relative_humidity$,wind_avg$,wind_direction$,wind_direction_cardinal$,wind_gust$,solar_radiation$,iconnow$
  DIM uv$,feels_like$,dew_point$,wet_bulb_temperature$,delta_t$,air_density$,lightning_strike_last_distance$
  DIM lightning_strike_last_epoch$,precip_accum_local_yesterday$,precip_accum_local_day$,dow1$,ss$,dow2$,dow3$,dow4$,dow5$,tag$
  DIM h2$,h3$,h4$,h5$,h6$,h99$,h7$,cxx,cyy,minutesrunning,sec,secs1
  DIM as Integer aa1,bb1,PM1,PM2,PM3,d1,d2,d3,d4,d5,d6,n,cs,css,ck1,ck2
  DIM DOW$(6) as string 'day of the week
  DIM Year,Month,Day,Second,p,ra,z1,z2,z3,w1,w2,w3,speednow2,speednow3,lightning1,gustnow1,temphigh1,templow1
  DIM OldDay,tz,moonage,moonphase,uv1,gustnow2,h98,ls1,sr$,e$,d$
  DOW$(0)="Sunday":DOW$(1)="Monday":DOW$(2)="Tuesday":DOW$(3)="Wednesday":DOW$(4)="Thursday":DOW$(5)="Friday":DOW$(6)="Saturday"
  SetTick 1000,UpDateTime,1   'Call every second, print date/time
  dim cx% = 785 'centre of compass X
  dim cy% = 238 'centre of compass Y
  dim wid% = 105 'Width of compass
  dim ang! = 0.087266463
  dim rad90! = 1.570796327  '90 degrees in radians
  Const pivot_x=cx%+15 'specify where the centre of the Compass dial is located
  Const pivot_y=cy%+15
  Const radius=wid%-4 'specify the radius of the compass dial
  Const side_length=17    'specify the size of the equilateral triangle pointer
  'define the points that make up the triangle relative to a pivot at 0,0
  Const x0=0                  'Triangle pointer
  Const x1=-side_length/2   'Triangle pointer
  Const x2=side_length/2   'Triangle pointer
  Const y0=-radius   'Triangle pointer
  Const y1=-radius+side_length*Cos(Rad(30)) 'Triangle pointer
  Const y2=y1   'Triangle pointer
  DIM integer angle, X, Y, W, H   'Triangle pointer
  DIM integer xx0,xx1,xx2,yy0,yy1,yy2   'variables holding the vertices of the triangle relative to its pivot
  DIM integer pxx0,pxx1,pxx2,pyy0,pyy1,pyy2 'variables holding the absolute vertices of the triangle
  dow1$ = DOW$(DayOfWeek(YEAR,MONTH,DAY)) 'day of week today
  WatchDog 30000    'IF program stops for 30 seconds THEN the cpu reboots
  on error skip
  secs1 = 0
  gustnow2 = 0 ' so initial reading is 0
  temphigh$ = "-10" ' temp will never be this low on power up
  templow$ = "30"  ' temp will never be this high on power up
  tempnow$  = " " 'clear data
  uvnow$ = "10" ' check to make sure UV works
  BOX 0,0,mm.hres,mm.vres/16,1,RGB(WHITE),RGB(162, 160, 160 )' top panel
  BOX 0 ,mm.vres/16,mm.hres/3,mm.vres/2-mm.vres/16,1,RGB(WHITE),RGB(185,208,240) 'upper left panel
  BOX mm.hres/3 ,mm.vres/16,mm.hres/3,mm.vres/2-mm.vres/16,1,RGB(WHITE),RGB(134,174,230) 'upper mid panel
  BOX  mm.hres/3*2     ,mm.vres/16,mm.hres/3,mm.vres/2-mm.vres/16,1,RGB(WHITE),RGB(185,208,240) 'upper right panel
  '  Text 1070,70,"Forecast for the next hour", LM,4,1 , RGB(BLACK),RGB(185,208,240) 'left 1 panel
  LINE 0,mm.vres/2,mm.hres,mm.vres/2,2,RGB(WHITE) 'dividing line
  BOX 0,0,mm.hres,mm.vres,1,RGB(WHITE)
  BOX mm.hres/4,mm.vres/2,mm.hres/4,mm.vres/1,1,RGB(WHITE) 'lower left panel
  BOX mm.hres/4*2,mm.vres/2,mm.hres/4,mm.vres/1,1,RGB(WHITE) 'lower left2 panel
  BOX mm.hres/4*3,mm.vres/2,mm.hres/4,mm.vres/1,1,RGB(WHITE) 'lower left3 panel
  BOX 0,mm.vres/2,mm.hres/4,mm.vres/16,1,RGB(WHITE),RGB(162, 160, 160 ) 'day1 panel
  BOX mm.hres/4,mm.vres/2,mm.hres/4,mm.vres/16,1,RGB(WHITE),RGB(162, 160, 160 ) 'day2 panel
  BOX mm.hres/4*2,mm.vres/2,mm.hres/4,mm.vres/16,1,RGB(WHITE),RGB(162, 160, 160 ) 'day3 panel
  BOX mm.hres/4*3,mm.vres/2,mm.hres/4,mm.vres/16,1,RGB(WHITE),RGB(162, 160, 160 ) 'day4 panel
  Text mm.hres-180 ,MM.VRES/70, DATE$, LT,4, 1, RGB(WHITE),RGB(162,160,160)   'Date
  Text 15,MM.VRES/70, DOW$(DayOfWeek(YEAR,MONTH,DAY)), LT,4, 1, RGB(WHITE),RGB(162,160,160)   'Day of the week
  '  Text MM.HRES/2-40,MM.VRES/70, TIME$, LT,4, 1, RGB(WHITE),RGB(162,160,160)   'display current time
  Text 600,400,"Waiting for Weather Update", LM,4,1 , RGB(BLACK),RGB(134,174,230) 'text while waiting for update
  OldDay = DAY - 1 ' so once run oldday will be today
  Load image "ne.bmp",864.2,158.8 'pictures used  but I'd prefer the words to be printed and not images
  Load image "se.bmp",864.2,317.2 'pictures used  but I'd prefer the words to be printed and not images 
  Load image "sw.bmp",705.8,317.2 'pictures used  but I'd prefer the words to be printed and not images
  Load image "nw.bmp",705.8,158.8 'pictures used  but I'd prefer the words to be printed and not images
  compass_rose cx%, cy%, wid%     'display compass on screen
  minutesrunning = 0  'test to see how long the program runs without crashing
 '--- Main program Loop--- 
  print #1, "66 77 225 00 00 01 112"  ' set pms5003 sensor to passive mode
DO
    Year=Val(Mid$(Date$,7,4)):Month=Val(Mid$(Date$,4,2)):Day=Val(Mid$(Date$,1,2))
    dow1$ = DOW$(DayOfWeek(YEAR,MONTH,DAY)) 'day of week today
    IF Day <> OldDay then 'day has changed update the display to reflect this
      Text mm.hres-180 ,MM.VRES/70,"          ", LT,4, 1, RGB(WHITE),RGB(162,160,160)  'Clear date
      Text mm.hres-180 ,MM.VRES/70, DATE$, LT,4, 1, RGB(WHITE),RGB(162,160,160)   'Date
      Text 15,MM.VRES/70, "          ", LT,4, 1, RGB(WHITE),RGB(162,160,160)   'Clear Day
      Text 15,MM.VRES/70, DOW$(DayOfWeek(YEAR,MONTH,DAY)), LT,4, 1, RGB(WHITE),RGB(162,160,160)   'Day of the week
      th$ = tempnow$  'data for reading
      tl$ = tempnow$  'data for reading
    END IF
   ss$=mid$(time$,7,2)  'ss$ = second 
   IF ss$ <> sec1$ THEN 'do something here every second if needed
   sec1$ = ss$   'secs1 is counter in seconds
   secs1 = secs1 + 1 ' counts up every second
   END IF 
 ' we need to wait 30 seconds for the pms5003 to stabilise
    if secs1 = 1 then  
    print #1, "66 77 228 00 01 01 116"      ' wakeup pms5003 send data to COM1
	print "pms5003 awake waiting 30 seconds for data"
	pause 996
	end if
    if secs1 = 30 then  read1 'read pms5003 data   (go to this sub) read1
    if secs1 = 40 then  read1 'read pms5003 data   (go to this sub) read1
    if secs1 = 50 then  read1 'read pms5003 data   (go to this sub) read1
	if secs1 = 51 then print #1, "66 77 228 00 00 01 115"   ' standby mode pms5003  send data to COM1
    if secs1 = 300 then secs1 = 0    'reset counter as we want pms5003 readings every 5 minutes	
   
   If RIGHT$(TIME$,2) = "54" Then 'Get forecast ready for processing every 60 seconds 
    system "wget -q -O- "+q$+"http://swd.weatherflow.com/swd/rest/better_forecast?api_key=20c70eae-e62f-4d3b-b3a4-8586e90f3ac8&station_id=10170&lat=53.439&lon=-2.106"+q$,c() 'get forecast ready to parse - this data is large!
	longstring print c()
    END If
      	
   ' If RIGHT$(TIME$,2) = "57" Then 'Get data from Air device ready for processing
    system "wget -q -O- "+q$+"https://swd.weatherflow.com/swd/rest/observations/?device_id=35102&api_key=20c70eae-e62f-4d3b-b3a4-8586e90f3ac8"+q$,a()
   END If
        	
   'If RIGHT$(TIME$,2) = "00" Then 'Get data from Sky device ready for processing
    system "wget -q -O- "+q$+"https://swd.weatherflow.com/swd/rest/observations/?device_id=35103&api_key=20c70eae-e62f-4d3b-b3a4-8586e90f3ac8"+q$,b()
	
    Forecast 'Json parse data                 (go to this sub)
    Air	'Json parse data                      (go to this sub)
    Sky  'Json parse data                     (go to this sub)
    DAYSUB  'get the day of the week          (go to this sub)
    ComputeMoonPhase() ' Lunar day for image  (go to this sub)
    print #2, FIELD$(AirObs$, 3)     'send Outside temp to hc-12 device
	print #2, station_pressure$      'send Pressure to hc-12 device
	print #2, precpr4$               'send chance of precipitation in the next hour to to hc-12 device
	time2$ = time$
    
	UPDATE ' Update Display   (go to this sub)
	
	 print "Minutes running " + STR$(minutesrunning) 'print how long without crashing
	 minutesrunning = minutesrunning + 1
     System  "/opt/vc/bin/vcgencmd measure_temp"            'print GPU temperature on console
     System  "cat /sys/class/thermal/thermal_zone0/temp"    'Print CPU temperature (needs /100 ) on console
    END IF	
    OldDay = Day ' olday now is today
Loop
'---------------------------   



SUB UPDATE
  '****************************Panel 1****************************
      Text 1000,MM.VRES/70, "Weather updated " + time1$, LT,4, 1, RGB(WHITE),RGB(162,160,160)   'Time updated TOP OF SCREEN
      Text 5,70,"                                              ",LM,4,1, RGB(BLACK),RGB(185,208,240)  'clears line ready for new data
      Text 5,70,"Conditions" + " " + conditions$, LM,4,1 , RGB(BLACK),RGB(185,208,240) 'Print conditions +  'Print Air on display
      Text 270,110,"                         ", LM,4,1 , RGB(BLACK),RGB(185,208,240)  'clears line ready for new data
      Text 5,110,"Pressure trend:" + " " + pressure_trend$, LM,4,1 , RGB(BLACK),RGB(185,208,240)
      Text 5,155,"Temperature: " , LM,4,1 , RGB(BLACK),RGB(185,208,240) '
      Text 200,155,"            ", LM,4,1 , RGB(BLACK),RGB(185,208,240)	 'clears line ready for new data
      Text 200,155,tempnow1$, LM,4,1 , RGB(BLACK),RGB(185,208,240) 'temperature outside	
      Text 5,200,"Pressure: ", LM,4,1 , RGB(BLACK),RGB(185,208,240) '
      Text 165,200,"            ", LM,4,1 , RGB(BLACK),RGB(185,208,240)	 'clears line ready for new data
      Text 165,200,sea_level_pressure$ + "mb", LM,4,1 , RGB(BLACK),RGB(185,208,240) 'sea level pressure
      Text 5,245,"Humidity: ", LM,4,1 , RGB(BLACK),RGB(185,208,240) '
      Text 165,245,"     ", LM,4,1 , RGB(BLACK),RGB(185,208,240)  'clears line ready for new data
      Text 165,245,relative_humidity$ + "%", LM,4,1 , RGB(BLACK),RGB(185,208,240) 'humidity
      Text 5,290,"Feels like:        ", LM,4,1 , RGB(BLACK),RGB(185,208,240)  'clears line ready for new data
      Text 5,290,"Feels like:" + " " + feels_like$ +"`C", LM,4,1 , RGB(BLACK),RGB(185,208,240) ' feels like
      Text 185,335,"       ", LM,4,1 , RGB(BLACK),RGB(185,208,240)  'clears line ready for new data
      Text 5,335,"UV Index: " , LM,4,1 , RGB(BLACK),RGB(185,208,240)
      uvnow$ = STR$(uv1,1,1)
      	Text 165,335,uvnow$, LM,4,1 , RGB(BLACK),RGB(185,208,240) 'UV
  	    SELECT CASE uv1
        Case < 2.1
          uvnow1$ = "LOW"
          	 Text 230,335,uvnow1$, LM,4,1 , RGB(BLACK),RGB(GREEN) 'UV words 	
        Case < 5
          uvnow1$ = "Moderate"
        	 Text 230,335,uvnow1$, LM,4,1 , RGB(BLACK),RGB(YELLOW) 'UV words
        Case < 8
          uvnow1$ = "HIGH"
          	Text 230,335,uvnow1$, LM,4,1 , RGB(BLACK),rgb(255,69,0)'UV words
        Case < 11
          uvnow1$ = "Very High"
          	 Text 230,335,uvnow1$, LM,4,1 , RGB(BLACK),RGB(RED) 'UV words
        Case > 11
          uvnow1$ = "EXTREME"
           	 Text 230,335,uvnow1$, LM,4,1 , RGB(BLACK),rgb(238,130,238)'UV words
      END SELECT
      Text 5,380,"Precipitation today:" + " " + "       ", LM,4,1 , RGB(BLACK),RGB(185,208,240) 'clears line ready for new data
      Text 5,380,"Precipitation today:" + " " + precip_accum_local_day$ + " mm", LM,4,1 , RGB(BLACK),RGB(185,208,240)
      Load image iconnow$,360,80 'weather icon now
      BOX mm.hres/3 ,mm.vres/16,mm.hres/3,mm.vres/2-mm.vres/16,1,RGB(WHITE),RGB(134,174,230) 'upper mid

      '****************************Panel 2****************************'**"
      Text 600,400,"                          ", LM,4,1 , RGB(BLACK),RGB(134,174,230) 'clear waiting text
      compass_rose cx%, cy%, wid% 'display compass on screen
      moveto(angle)               'move compass pointer to this angle
      Text 540,80,"Wind coming from: " + "          ", LM,4,1 , RGB(BLACK),RGB(134,174,230) 'clears line ready for new data
      Text 540,80,"Wind coming from: " + wind_direction_cardinal$ + " " + direction$ + "`", LM,4,1 , RGB(BLACK),RGB(134,174,230)  '
      'previous line prints Wind coming from + wind direction in words + degree value on screen
      Text 540,135,"             ", LM,4,1 , RGB(BLACK),RGB(134,174,230) 'clears line ready for new data
      Text 540,135,"High: " + th$, LM,4,1 , RGB(BLACK),RGB(134,174,230)  'prints high + value of high temp on display
      Text mm.hres/2 + 80,135,"           ", LM,4,1 , RGB(BLACK),RGB(134,174,230) 'clears line ready for new data
      Text mm.hres/2 + 80,135,"Low " + tl$, LM,4,1 , RGB(BLACK),RGB(134,174,230) 'Print Low +  value of low temperature
      Text 540,320,"Wind Gust:", LM,4,1 , RGB(BLACK),RGB(134,174,230)   'Print Wind gust on display
      Text 540,355,"         ", LM,4,1 , RGB(BLACK),RGB(134,174,230) '	 'clears line ready for new data
      Text 540,355,wind_gust$, LM,4,1 , RGB(BLACK),RGB(134,174,230)  'Print value of wind gust on display
      'Text 540,400,"             "                                          'clears line ready for new data
      Text 540,400,"Wind " + wind$, LM,4,1 , RGB(BLACK),RGB(134,174,230)  'Print Wind +  value of wind speed on display
      Text 540,215,"Air" , LM,4,1 , RGB(BLACK),RGB(134,174,230)      'Print Air on display
      Text 540,255,"     " , LM,4,1 , RGB(BLACK),RGB(134,174,230)	 'clears line ready for new data
      Text 540,255,battery1$ , LM,4,1 , RGB(BLACK),RGB(134,174,230)  'display battery voltage for Air device
      Text 960,215,"Sky", LM,4,1 , RGB(BLACK),RGB(134,174,230)		 'Print Sky on display
      Text 960,255,"     ", LM,4,1 , RGB(BLACK),RGB(134,174,230)	 'clears line ready for new data
      Text 960,255,battery2$, LM,4,1 , RGB(BLACK),RGB(134,174,230)	 'display battery voltage for Sky device
      LOAD IMAGE STR$(CINT(moonage)) + ".bmp", 914, 270           'Display correct moon image for today
      '****************************Panel 3****************************
      Text 1070,70,"Last lightning strike", LM,4,1 , RGB(BLACK),RGB(185,208,240)'
      Text 1070,95,LEFT$(HumanTime(ls1),8) + " " + RIGHT$(HumanTime(ls1),8), LM,4,1 , RGB(BLACK),RGB(185,208,240)
      Text 1070,120,lightning_strike_last_distance$,LM,4,1 , RGB(BLACK),RGB(185,208,240)' 'lightning distance
      Text 1070,145,"Conditions next hr:", LM,4,1 , RGB(BLACK),RGB(185,208,240)'
      Text 1070,170,"                     ", LM,4,1 , RGB(BLACK),RGB(185,208,240)   'clears line ready for new data
      Text 1070,170,h2$, LM,4,1 , RGB(BLACK),RGB(185,208,240)      'Condition
      Text 1070,195,"                             ", LM,4,1 , RGB(BLACK),RGB(185,208,240)  'clears line ready for new data
      Text 1070,195,"POP:" + h4$, LM,4,1 , RGB(BLACK),RGB(185,208,240)'
      Text 1070,220,"Air Quality:", LM,4,1 , RGB(BLACK),RGB(185,208,240) 
      Text 1070,245,"                 ", LM,4,1 , RGB(BLACK),RGB(185,208,240)  'clears line ready for new data
      Text 1070,245,"PM1: " + STR$(PM1) , LM,4,1 , RGB(BLACK),RGB(185,208,240)
      Text 1070,270,"                 ", LM,4,1 , RGB(BLACK),RGB(185,208,240)  'clears line ready for new data
      Text 1070,270,"PM2.5: " + STR$(PM2) , LM,4,1 , RGB(BLACK),RGB(185,208,240)
      Text 1070,295,"                 ", LM,4,1 , RGB(BLACK),RGB(185,208,240)  'clears line ready for new data
      Text 1070,295,"PM10: " + STR$(PM3) , LM,4,1 , RGB(BLACK),RGB(185,208,240) 
      Text 1070,320,"                         ", LM,4,1 , RGB(BLACK),RGB(185,208,240)  'clears line ready for new data
      Text 1070,320,"particles > 0.3um" + " " + STR$(d1), LM,4,1 , RGB(BLACK),RGB(185,208,240)'
      Text 1070,345,"                         ", LM,4,1 , RGB(BLACK),RGB(185,208,240)  'clears line ready for new data
      Text 1070,345,"particles > 0.5um" + " " + STR$(d2), LM,4,1 , RGB(BLACK),RGB(185,208,240)'  
      Text 1070,370,"                         "), LM,4,1 , RGB(BLACK),RGB(185,208,240)  'clears line ready for new data   
      Text 1070,370,"particles > 1um" + " " + STR$(d3), LM,4,1 , RGB(BLACK),RGB(185,208,240)'  
      Text 1070,395,"                         ", LM,4,1 , RGB(BLACK),RGB(185,208,240)  'clears line ready for new data  
      Text 1070,395,"particles > 2.5um" + " " + STR$(d4), LM,4,1 , RGB(BLACK),RGB(185,208,240)'  
      Text 1070,425,"                         ", LM,4,1 , RGB(BLACK),RGB(185,208,240)   'clears line ready for new data   
      Text 1070,425,"particles > 5um" + " " + STR$(d5), LM,4,1 , RGB(BLACK),RGB(185,208,240)'   
      Load image "kia.bmp",1355,95
      Load image h3$,1460,300      'display weather icon now  			
      '****************************Panel B1****************************
      Text 110,470,"            ", LT,4, 1, RGB(WHITE),RGB(162,160,160)  'clears line ready for new data
      Text 110,470,dow2$, LT,4, 1, RGB(WHITE),RGB(162,160,160)   'Day of the week forecast 1
      Text 5,520,"Conditions" , LM,4,1 , RGB(BLACK), RGB(42,117,198)	
      Text 5,545, "                    " , LM,4,1 , RGB(BLACK), RGB(42,117,198)	 'clears line ready for new data
      Text 5,545,cond1$  , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 5,580,"High Temperature" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 5,605,"                 " , LM,4,1 , RGB(BLACK), RGB(42,117,198)  'clears line ready for new data
      Text 5,605,thigh1$ +"`C", LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 5,640,"Low Temperature" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 5,665,"        " , LM,4,1 , RGB(BLACK), RGB(42,117,198)   'clears line ready for new data
      Text 5,665,tlow1$ +"`C" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 5,700,"Chance of Precipition" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 5,725,"        " , LM,4,1 , RGB(BLACK), RGB(42,117,198)   'clears line ready for new data
      Text 5,725,precpr1$ + "%"  , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 5,750,"Precipitation Type" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 5,785,"               " , LM,4,1 , RGB(BLACK), RGB(42,117,198)   'clears line ready for new data
      Text 5,785,preciptype1$ , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      icon1$ = icon1$ + "1.bmp"
      Load image icon1$,150,760 'weather icon now

      '****************************Panel B2****************************	
      Text 510,470,"            ", LT,4, 1, RGB(WHITE),RGB(162,160,160) 'Clear panel
      Text 510,470,dow3$, LT,4, 1, RGB(WHITE),RGB(162,160,160)   'Day of the week	forecast 2
      Text 405,520,"Conditions" , LM,4,1 , RGB(BLACK), RGB(42,117,198)	
      Text 405,545, "                    " , LM,4,1 , RGB(BLACK), RGB(42,117,198)	
      Text 405,545,cond2$ , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 405,580,"High Temperature" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 405,605,"                 " , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 405,605,thigh2$+"`C", LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 405,640,"Low Temperature" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 405,665,"        " , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 405,665,tlow2$ +"`C", LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 405,700,"Chance of Precipition" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 405,725,"        " , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 405,725,precpr2$ + "%" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 405,750,"Precipitation Type" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 405,785,"                 " , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 405,785,preciptype2$, LM,4,1 , RGB(BLACK), RGB(42,117,198)
      icon2$ = icon2$ + "1.bmp"
      Load image icon2$,550,760 'weather icon now  	
      icon2$ = "--_"
      '****************************Panel B3****************************	
      Text 910,470,"            ", LT,4, 1, RGB(WHITE),RGB(162,160,160) 'Clear panel
      Text 910,470,dow4$, LT,4, 1, RGB(WHITE),RGB(162,160,160)   'Day of the week	forecast 3
      Text 805,520,"Conditions" , LM,4,1 , RGB(BLACK), RGB(42,117,198)	
      Text 805,545, "                    " , LM,4,1 , RGB(BLACK), RGB(42,117,198)	
      Text 805,545,cond3$  , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 805,580,"High Temperature" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 805,605,"                 " , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 805,605,thigh3$ +"`C" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 805,640,"Low Temperature" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 805,665,"        " , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 805,665,tlow3$ +"`C" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 805,700,"Chance of Precipition" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 805,725,"        " , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 805,725,precpr3$ + "%" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 805,750,"Precipitation Type" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 805,785,"               " , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 805,785,preciptype3$ , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      icon3$ = icon3$ + "1.bmp"
      Load image icon3$,950,760 'weather icon now  	
      icon3$ = "--_"
      '****************************Panel B4****************************	
      Text 1310,470,"            ", LT,4, 1, RGB(WHITE),RGB(162,160,160) 'Clear panel
      Text 1310,470,dow5$, LT,4, 1, RGB(WHITE),RGB(162,160,160)   'Day of the week forecast 4
      Text 1205,520,"Conditions" , LM,4,1 , RGB(BLACK), RGB(42,117,198)	
      Text 1205,545, "                    " , LM,4,1 , RGB(BLACK), RGB(42,117,198)	
      Text 1205,545,cond4$, LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 1205,580,"High Temperature" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 1205,605,"                 " , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 1205,605,thigh4$ +"`C", LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 1205,640,"Low Temperature" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 1205,665,"        " , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 1205,665,tlow4$ +"`C", LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 1205,700,"Chance of Precipition" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 1205,725,"        " , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 1205,725,precpr4$ + "%", LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 1205,750,"Precipitation Type" , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 1205,785,"               " , LM,4,1 , RGB(BLACK), RGB(42,117,198)
      Text 1205,785,preciptype4$, LM,4,1 , RGB(BLACK), RGB(42,117,198)	
      icon4$ = icon4$ + "1.bmp"
      Load image icon4$,1350,760 'weather icon now  	
      icon4$ = "--_"
      '****************************************************************
END Sub
'   

SUB read1
    print #1, "66 77 226 00 00 01 113" 'pms5003 passive mode read 
    e$ = INPUT$(1,#1)  ' get data from com1 
    d$ = d$ + e$ ' add data to get one full line of 32 characters
    IF Len(d$) = 32 Then  ' if data contains 32 characters then probably valid data 
      decode    (go to this sub)
      d$ = "" 'clear b$ ready for next read
      	  PRINT "PM1 = ", PM1                                  'print on console for debugging 
      	  PRINT "PM2.5 = " PM2                                 'print on console for debugging 
      	  PRINT "PM10 = " PM3                                  'print on console for debugging 
      	  PRINT STR$(d1) + " particles with diameter > 0.3um " 'print on console for debugging 
      	  PRINT STR$(d2) + " particles with diameter > 0.5um " 'print on console for debugging 
      	  PRINT STR$(d3) + " particles with diameter > 1um "   'print on console for debugging 
      	  PRINT STR$(d4) + " particles with diameter > 2.5"    'print on console for debugging 
      	  PRINT STR$(d5) + " particles with diameter > 5um "   'print on console for debugging 
      	  PRINT STR$(d6) + " particles with diameter > 10um "  'print on console for debugging    
   print #1,  "66 77 228 00 00 01 115"  'standby mode   send command via com1
	end if
END SUB	

sub decode
  for n = 1 to 32
    print asc(mid$(d$,n,1)); : print ",";  'Debug use to see the data
  next n
  print
  IF left$(d$,2) = "BM" then ' Only proceed if probable Valid data is received
    aa1 = asc(mid$(d$,3)) 'Should be 0
    bb1 = asc(mid$(d$,4)) 'Should be 28
    if aa1 + bb1 = 28 then ' data length is correct we probably have valid data
      css =asc(mid$(d$,31,1))*256+asc(mid$(d$,32,1)) ' Calculate Checksum
      for n = 1 to 30
        cs = cs + asc(mid$(d$,n,1))
      next n
      If cs = css then   'CHECKSUM correct we can use the data
         ' print "Checksum OK"  'debug use
        cs = 0
	if ck1 =  asc(mid$(d$,31)) and ck2 = asc(mid$(d$,32)) then end sub ' if data is same as previous data disregard
        'Only need values from Data7 high to Data12 low
        PM1= asc(mid$(d$,11)) * 256 + asc(mid$(d$,12))   'PM1.0 concentration unit  μg/m3（under atmospheric environment）
        PM2 = asc(mid$(d$,13)) * 256 + asc(mid$(d$,14))  'PM2.5 concentration unit  μg/m3（under atmospheric environment）
        PM3 =  asc(mid$(d$,15)) * 256 + asc(mid$(d$,16)) 'PM10  concentration unit  μg/m3(under atmospheric environment)
        d1 =   asc(mid$(d$,17)) * 256 + asc(mid$(d$,18)) 'Number of particles with diameter > 0.3um in 0.1L of air
        d2 =   asc(mid$(d$,19)) * 256 + asc(mid$(d$,20)) 'Number of particles with diameter > 0.5um in 0.1L of air
        d3 =   asc(mid$(d$,21)) * 256 + asc(mid$(d$,22)) 'Number of particles with diameter > 1.0um in 0.1L of air
        d4 =   asc(mid$(d$,23)) * 256 + asc(mid$(d$,24)) 'Number of particles with diameter > 2.5um in 0.1L of air
        d5 =   asc(mid$(d$,25)) * 256 + asc(mid$(d$,26)) 'Number of particles with diameter > 5.0um in 0.1L of air
        d6 =   asc(mid$(d$,27)) * 256 + asc(mid$(d$,28)) 'Number of particles with diameter > 10um in 0.1L of air
      END IF
    END IF
	end if
	end if
	ck1 = asc(mid$(d$,31)) 'put new data into ck1
	ck2 = asc(mid$(d$,32)) 'put new data into ck2	
END SUB
    


Sub Air 'Parse data from Air Device
          i=LINSTR(a(),q$+"obs"+q$+":[[")+8  'ie skip over "obs":[[
          AirObs$=LGETSTR$(a(),i,255)
          press1$ = FIELD$(AirObs$, 2) 'Station Pressure (MB)
          tempnow$ = FIELD$(AirObs$, 3) 'Air Temperature (C)
		  IF tempnow$ = "null" then tempnow$ = ""
          IF VAL(tempnow$) > VAL(temphigh$) then
            temphigh$ = tempnow$
          END IF
          IF VAL(tempnow$) < VAL(templow$) then
            templow$ = tempnow$
          END IF
          tempnow1$ = tempnow$ + "`C"
          th$ = temphigh$ + "`C"
          tl$ = templow$ + "`C"	
        END IF
        battery1$ = FIELD$(AirObs$, 7) 'Battery (volts)
        battery1$ = battery1$ + "V" ' AIR BATTERY
END SUB
'        
Sub Sky 'Parse data from Sky Device
        j=LINSTR(b(),q$+"obs"+q$+":[[")+8  'ie skip over "obs":[[
        SkyObs$=LGETSTR$(b(),j,255)
        wind$ = FIELD$(SkyObs$, 6) 'Wind Avg (m/s)
		IF wind$ = "null" then wind$ = "0"
        speednow2 = VAL(wind$)
        speednow3 = speednow2 * 2.23694 'Convert mps to mph
        wind$ = STR$(speednow3,2,1 ) +" mph"
        direction$ = FIELD$(SkyObs$, 8)'Wind Direction (degrees)
		IF direction$ = "null" then direction$ = "0"
        angle = VAL(direction$)
        select case angle
          case = 0
            angle = 180
          case is < 180
            angle = angle + 180
          case = 180
            angle = 360
          case is < 360
            angle = angle - 180
        END select
        battery2$ = FIELD$(SkyObs$, 9)   'Battery (volts)
        battery2$ = battery2$ + "V" ' Sky BATTERY
        uvnow$ = FIELD$(SkyObs$, 3)  'UV index
END SUB
'
SUB Forecast ' get Weather forecast for my location
conditions$ = JSON$(c(),"current_conditions.conditions")
iconnow$ = JSON$(c(),"current_conditions.icon")
IF iconnow$ = "null" then iconnow$ = "--_"  'icon replacement
iconnow$ = iconnow$ +".bmp"
air_temperature$ = JSON$(c(),"current_conditions.air_temperature")
sea_level_pressure$ = JSON$(c(),"current_conditions.sea_level_pressure")
station_pressure$ = JSON$(c(),"current_conditions.station_pressure")
pressure_trend$ = JSON$(c(),"current_conditions.pressure_trend")
relative_humidity$ = JSON$(c(),"current_conditions.relative_humidity")
wind_avg$ = JSON$(c(),"current_conditions.wind_avg")
wind_direction$ = JSON$(c(),"current_conditions.wind_direction")
wind_direction_cardinal$ = JSON$(c(),"current_conditions.wind_direction_cardinal")
wind_gust$ = JSON$(c(),"current_conditions.wind_gust")
IF wind_gust$   = "null" THEN wind_gust$  = "0" 'gust
gustnow1 = VAL(wind_gust$ )
if gustnow2 < gustnow1 then
gustnow2 = gustnow1
gustnow2 = gustnow2 * 2.23694 'Convert mps to mph
end if
wind_gust$ = STR$(gustnow2,1,1) +" mph"
solar_radiation$ = JSON$(c(),"current_conditions.solar_radiation")
uv$ = JSON$(c(),"current_conditions.uv")
feels_like$ = JSON$(c(),"current_conditions.feels_like")
dew_point$ = JSON$(c(),"current_conditions.dew_point")
wet_bulb_temperature$ = JSON$(c(),"current_conditions.wet_bulb_temperature")
delta_t$ = JSON$(c(),"current_conditions.delta_t")
air_density$ = JSON$(c(),"current_conditions.air_density")
lightning_strike_last_distance$ = JSON$(c(),"current_conditions.lightning_strike_last_distance")
IF lightning_strike_last_distance$ = "null" THEN lightning_strike_last_distance$ = "0"
lightning1 = val(lightning_strike_last_distance$)
lightning1 = lightning1 * 0.621371
lightning_strike_last_distance$ = STR$(lightning1,0,2)+" miles"
lightning_strike_last_epoch$ = JSON$(c(),"current_conditions.lightning_strike_last_epoch")
ls1 = VAL(lightning_strike_last_epoch$)
precip_accum_local_yesterday$ = JSON$(c(),"current_conditions.precip_accum_local_yesterday")
precip_accum_local_day$ = JSON$(c(),"current_conditions.precip_accum_local_day")
cond1$ = JSON$(c(),"forecast.daily[1].conditions") ' Conditions Day 1
icon1$ = JSON$(c(),"forecast.daily[1].icon") 'Icon Day 1
thigh1$ = JSON$(c(),"forecast.daily[1].air_temp_high") 'Temp High Day 1
tlow1$ = JSON$(c(),"forecast.daily[1].air_temp_low") 'Temp Low Day 1
precpr1$ = JSON$(c(),"forecast.daily[1].precip_probability") 'Precipitation Probability Day 1
precpicon1$ = JSON$(c(),"forecast.daily[1].precip_icon") 'Precipitation Icon Day 1
preciptype1$ = JSON$(c(),"forecast.daily[1].precip_type") 'Precipitation Type Day 1
thighColour1$ = JSON$(c(),"forecast.daily[1].air_temp_high_color") 'Temp High Colour Day 1
tlowColour1$ = JSON$(c(),"forecast.daily[1].air_temp_low_color") 'Temp Low Colour Day 1
cond2$ = JSON$(c(),"forecast.daily[2].conditions") ' Conditions Day 2
icon2$ = JSON$(c(),"forecast.daily[2].icon") 'Icon Day 2
thigh2$ = JSON$(c(),"forecast.daily[2].air_temp_high") 'Temp High Day 2
tlow2$ = JSON$(c(),"forecast.daily[2].air_temp_low") 'Temp Low Day 2
precpr2$ = JSON$(c(),"forecast.daily[2].precip_probability") 'Precipitation Probability Day 2
precpicon2$ = JSON$(c(),"forecast.daily[2].precip_icon") 'Precipitation Icon Day 2
preciptype2$ = JSON$(c(),"forecast.daily[2].precip_type") 'Precipitation Type Day 2
thighColour2$ = JSON$(c(),"forecast.daily[2].air_temp_high_color") 'Temp High Colour Day 2
tlowColour2$ = JSON$(c(),"forecast.daily[2].air_temp_low_color") 'Temp Low Colour Day 2
cond3$ = JSON$(c(),"forecast.daily[3].conditions") ' Conditions Day 3
icon3$ = JSON$(c(),"forecast.daily[3].icon") 'Icon Day 3
thigh3$ = JSON$(c(),"forecast.daily[3].air_temp_high") 'Temp High Day 3
tlow3$ = JSON$(c(),"forecast.daily[3].air_temp_low") 'Temp Low Day 3
precpr3$ = JSON$(c(),"forecast.daily[3].precip_probability") 'Precipitation Probability Day 3
precpicon3$ = JSON$(c(),"forecast.daily[3].precip_icon")'Precipitation Icon Day 3
preciptype3$ = JSON$(c(),"forecast.daily[3].precip_type") 'Precipitation Type Day 3
thighColour3$ = JSON$(c(),"forecast.daily[3].air_temp_high_color") 'Temp High Colour Day 3
tlowColour3$ = JSON$(c(),"forecast.daily[3].air_temp_low_color") 'Temp Low Colour Day 3
cond4$ = JSON$(c(),"forecast.daily[4].conditions") ' Conditions Day 4
icon4$ = JSON$(c(),"forecast.daily[4].icon") 'Icon Day 4
thigh4$ = JSON$(c(),"forecast.daily[4].air_temp_high") 'Temp High Day 4
tlow4$ = JSON$(c(),"forecast.daily[4].air_temp_low") 'Temp Low Day 4
precpr4$ = JSON$(c(),"forecast.daily[4].precip_probability") 'Precipitation Probability Day 4
precpicon4$ = JSON$(c(),"forecast.daily[4].precip_icon")'Precipitation Icon Day 4
preciptype4$ = JSON$(c(),"forecast.daily[4].precip_type") 'Precipitation Type Day 4
thighColour4$ = JSON$(c(),"forecast.daily[4].air_temp_high_color") 'Temp High Colour Day 4
tlowColour4$ = JSON$(c(),"forecast.daily[4].air_temp_low_color") 'Temp Low Colour Day 4
h2$ = JSON$(c(),"forecast.hourly[0].conditions")
h3$ = JSON$(c(),"forecast.hourly[0].icon")
h4$ = JSON$(c(),"forecast.hourly[0].precip_probability")
IF h4$ = "null" then h4$ = "0"
h4$ = h4$ + "%"
h5$ = JSON$(c(),"forecast.hourly[0].precip_type")
IF h5$ = "null" then h5$ = "0"
h99$ = right$(h4$,2)
h98 = val(h99$)
if h98 = 0 then h5$ = "none"
h6$ = JSON$(c(),"forecast.hourly[0].feels_like")
h6$ = h6$ + "`C"

time1$ = time$  ' time1$ = current time which is the time of weather update for printing at the top of the screen


Text 280,MM.VRES/70, "Battery:", LT,4, 1, RGB(WHITE),RGB(162,160,160)   'Charge Status

Text 5,425,"Solar Radiation " + "        " , LM,4,1 , RGB(BLACK),RGB(185,208,240)'clear read for next print
Text 5,425,"Solar Radiation " + STR$(VAL(solar_radiation$,1,1)) + "W/m2" , LM,4,1 , RGB(BLACK),RGB(185,208,240) ' display in 1st panel on screen
 
if val(sr$) < 60 then
Text 420,MM.VRES/70, "not charging", LT,4, 1, RGB(WHITE),RGB(162,160,160)   'BATTERY Status
Endif
If val(Sr$) > 59 then
Text 425,MM.VRES/70, "            ", LT,4, 1, RGB(WHITE),RGB(162,160,160)   'clear read for next print
Text 425,MM.VRES/70, "Charging", LT,4, 1, RGB(WHITE),RGB(GREEN)   'BATTERY Status
Endif
Endif

'*** if solar radiation is < 60 then print not charging beside battery status at top of screen***
'*** if Solar radiation is = or > than 60 then  print  charging beside battery status at top of screen*** HIGHLIGHTED IN GREEN



END Sub
'     
       
Sub MoonImage 'Get the correct moon image for today
 Select Case moonage
        Case  = 0
          Load image "0.bmp",910,270 'weather moon icon
        Case IS > 0, IS  <= 1
          Load image "0.bmp",910,270 'weather moon icon
        Case IS > 1, IS   <= 2
          Load image "1.bmp",910,270 'weather moon icon
        Case IS > 2, IS  <= 3
          Load image "2.bmp",910,270 'weather moon icon
        Case IS > 3, IS  <= 4
          Load image "3.bmp",910,270 'weather moon icon
        Case IS > 4, IS  <= 5
          Load image "4.bmp",910,270 'weather moon icon
        Case IS > 5, IS  <= 6
          Load image "5.bmp",910,270 'weather moon icon
        Case IS > 6, IS   <= 7
          Load image "6.bmp",910,270 'weather moon icon
        Case IS > 7, IS   <= 8
          Load image "7.bmp",910,270 'weather moon icon
        Case IS > 8, IS  <= 9
          Load image "8.bmp",910,270 'weather moon icon
        Case IS > 9, IS  <= 10
          Load image "9.bmp",910,270 'weather moon icon
        Case IS > 10, IS  <= 11
          Load image "10.bmp",910,270 'weather moon icon
        Case IS > 11, IS  <= 12
          Load image "11.bmp",910,270 'weather moon icon
        Case IS > 12, IS  <=13
          Load image "12.bmp",910,270 'weather moon icon
        Case IS > 13, IS  <= 14
          Load image "13.bmp",910,270 'weather moon icon
        Case IS > 14, IS  <= 15
          Load image "14.bmp",910,270 'weather moon icon
        Case IS > 15, IS  <= 16
          Load image "15.bmp",910,270 'weather moon icon
        Case IS > 16, IS  <= 17
          Load image "16.bmp",910,270 'weather moon icon
        Case IS > 17, IS  <= 18
          Load image "17.bmp",910,270 'weather moon icon
        Case IS > 18, IS  <= 19
          Load image "18.bmp",910,270 'weather moon icon
        Case IS > 19, IS  <= 20
          Load image "19.bmp",910,270 'weather moon icon
        Case IS > 20, IS  <= 21
          Load image "20.bmp",910,270 'weather moon icon
        Case IS > 21, IS  <= 22
          Load image "21.bmp",910,270 'weather moon icon
        Case IS > 22, IS  <= 23
          Load image "22.bmp",910,270 'weather moon icon
        Case IS > 23, IS  <= 24
          Load image "23.bmp",910,270 'weather moon icon
        Case IS > 24, IS  <= 25
          Load image "24.bmp",910,270 'weather moon icon
        Case IS > 25, IS  <= 26
          Load image "25.bmp",910,270 'weather moon icon
        Case IS > 26, IS  <= 27
          Load image "26.bmp",910,270 'weather moon icon
        Case IS > 27, IS  <= 28
          Load image "27.bmp",910,270 'weather moon icon
        Case IS > 28, IS  <= 29
          Load image "28.bmp",910,270 'weather moon icon
        Case IS > 29, IS  <= 30
          Load image "29.bmp",910,270 'weather moon icon  
      END select 
End sub
'      	
SUB ComputeMoonPhase()
      LOCAL FLOAT jd,N,M,Ec,Ls,ml,MM,MN,Ev,Ae,A3,MmP,mEc,A4,lP,V,lPP,NP,y,x
      LOCAL FLOAT Lm,BM,delta,TO_RAD,TO_DEG
      ' Constants for the Sun and the Moon at julian date 1980-01-00
      CONST MAfactor=0.9856473321
      CONST Elonge=278.83354
      CONST Elongp=282.596403
      CONST Eccent=0.016718
      CONST Eccent2=1.016860112
      CONST Mlfactor=13.1763966
      CONST Mmlong=64.975464
      CONST MMfactor=0.1114041
      CONST Mmlongp=349.383063
      CONST Mlnode=151.950429
      CONST MNfactor=0.0529539
      CONST Evfactor=1.2739
      CONST Aefactor=0.1858
      CONST A3factor=0.37
      CONST mEcfactor=6.2886
      CONST A4factor=0.214
      CONST Vfactor=0.6583
      CONST NPfactor=0.16
      CONST CosMinc=0.995970321:' COS(TO_RAD*5.145396)
      CONST SinMinc=8.9683442e-2:' SIN(TO_RAD*5.145396)
      CONST Synmonth=29.53058868
      ' Was 1e-6 in initial algorithm, but we only have simple precision floats
      CONST EPSILON=1e-5
      ' 7306=days elapsed between 2000-01-01 and 1980-01-00=1979-12-31
      jd=JD2000(DATE$,TIME$)+7306
      N=MAfactor*jd:N=N-N\360*360.0
      M=N+Elonge-Elongp:M=M-M\360*360.0:M=TO_RAD*M
      Ec=M
      DO
        delta=Ec-Eccent*SIN(Ec)-M
        Ec=Ec-delta/(1-Eccent*COS(Ec))
      LOOP UNTIL ABS(delta)<=EPSILON
      Ec=Eccent2*TAN(Ec/2.0):Ec=2*TO_DEG*ATN(Ec)
      Ls=Ec+Elongp:Ls=Ls-Ls\360*360.0
      ml=Mlfactor*jd+Mmlong:ml=ml-ml\360*360.0
      MM=ml-MMfactor*jd-Mmlongp:MM=MM-MM\360*360.0
      MN=Mlnode-MNfactor*jd
      Ev=Evfactor*SIN(TO_RAD*(2*(ml-Ls)-MM))
      Ae=Aefactor*SIN(M):A3=A3factor*SIN(M)
      MmP=MM+Ev-Ae-A3
      mEc=mEcfactor*SIN(TO_RAD*MmP):A4=A4factor*SIN(TO_RAD*2*MmP)
      lP=ml+Ev+mEc-Ae+A4
      V=Vfactor*SIN(TO_RAD*2*(lP-Ls)):lPP=lP+V
      NP=MN-NPfactor*SIN(M)
      y=SIN(TO_RAD*(lPP-NP))*CosMinc:x=COS(TO_RAD*(lPP-NP))
      Lm=TO_DEG*ATAN2(y,x)+NP
      BM=TO_DEG*ASIN(SIN(TO_RAD*(lPP-NP))*SinMinc)
      moonage=lPP-Ls
      moonage=moonage-moonage\360*360.0:IF moonage<0 THEN moonage=moonage+360.0
      moonphase=0.5-COS(TO_RAD*moonage)/2.0
      moonage=Synmonth*moonage/360.0
	  print moonage
	  pause 700
END SUB
'	  
Sub DAYSUB 'get the day of the week
      IF dow1$ = "Monday" Then
        dow2$ = "Tuesday" : dow3$ = "Wednesday"
        dow4$ = "Thursday" : dow5$ = "Friday"
      END IF
      IF dow1$ = "Tuesday" Then
        dow2$ = "Wednesday" : dow3$ = "Thursday"
        dow4$ = "Friday" :dow5$ = "Saturday"
      END IF
      IF dow1$ = "Wednesday" Then
        dow2$ = "Thursday": dow3$ = "Friday"
        dow4$ = "Saturday": dow5$ = "Sunday"
      END IF
      IF dow1$ = "Thursday" Then
        dow2$ = "Friday" : dow3$ = "Saturday"
        dow4$ = "Sunday" : dow5$ = "Monday"
      END IF
      IF dow1$ = "Friday" Then
        dow2$ = "Saturday" : dow3$ = "Sunday"
        dow4$ = "Monday": dow5$ = "Tuesday"
      END IF
      IF dow1$ = "Saturday" Then
        dow2$ = "Sunday" : dow3$ = "Monday"
        dow4$ = "Tuesday" : dow5$ = "Wednesday"
      END IF
      IF dow1$ = "Sunday" Then
        dow2$ = "Monday" : dow3$ = "Tuesday"
        dow4$ = "Wednesday" : dow5$ = "Thursday"
      END IF
END Sub
'     
sub compass_rose cx%,cy%,wid% 'on screen compass
Local a%
Text cx%+9,cy%+15-(wid%+22),"N",L,4,,RGB(1,1,1),RGB(134,174,230)
Text cx%+9,cy%+15+(wid%+5),"S",L,4,,RGB(1,1,1),RGB(134,174,230)
Text cx%+wid%+18,cy%+4,"E",L,4,,RGB(1,1,1),RGB(134,174,230)
Text cx%-(wid%+5),cy%+4,"W",L,4,,RGB(1,1,1),RGB(134,174,230)
' tick marks, every 5 degrees (360/5 = 72)
For a% = 0 To 71
  Line (cx%+15)+(Cos(a%*ang!)*(wid%-4)),(cy%+15)-(Sin(a%*ang!)*(wid%-4)),(cx%+15)+(Cos(a%*ang!)*(wid%+1)),(cy%+15)-(Sin(a%*ang!)*(wid%+1)),,RGB(WHITE)
Next
' compass perimiter
Circle cx%+15,cy%+15,wid%
Circle cx%+15,cy%+15,wid%-4
' pointers to intermediate directions (not sure why I need 1 to 8 here!, besides bad math :-) )
for a% = 1 to 8
  triangle cx%+15-sin(9*a%*ang!)*wid%*.5,cy%+15-cos(9*a%*ang!)*wid%*.5,cx%+15+cos(9*a%*ang!)*wid%*.07,cy%+15-sin(9*a%*ang!)*wid%*.07,cx%+15-cos(9*a%*ang!)*wid%*.07,cy%+15+sin(9*a%*ang!)*wid%*.07,RGB(WHITE),RGB(WHITE)
next
line cx%+15-sin(9*a%*ang!)*wid%*.5,cy%+15-cos(9*a%*ang!)*wid%*.5,cx%+15+sin(9*a%*ang!)*wid%*.5,cy%+15+cos(9*a%*ang!)*wid%*.5,,RGB(BLACK)
line cx%+15-sin(9*a%*ang!)*wid%*.5,cy%+15+cos(9*a%*ang!)*wid%*.5,cx%+15+sin(9*a%*ang!)*wid%*.5,cy%+15-cos(9*a%*ang!)*wid%*.5,,RGB(BLACK)
' pointers to cardinal directions
for a% = 0 to 3
  triangle cx%+15-sin(a%*rad90!)*(wid%+2),cy%+15-cos(a%*rad90!)*(wid%+2),cx%+15+cos(a%*rad90!)*wid%*.11,cy%+15+sin(a%*rad90)*wid%*.11,cx%+15-cos(a%*rad90!)*wid%*.11,cy%+15-sin(a%*rad90!)*wid%*.11,RGB(RED),RGB(RED)
next
line cx%+15,cy%+15+wid%*.99,cx%+15,cy%+15-wid%*.99,,RGB(BLACK)
line cx%+15-wid%*.99,cy%+15,cx%+15+wid%*.99,cy%+15,,RGB(BLACK)
circle cx%+15,cy%+16,wid%*.18,,,RGB(BLACK),RGB(GREEN)
circle cx%+15,cy%+16,wid%*.13,,,RGB(BLUE),RGB(BLUE)
circle cx%+15,cy%+16,wid%*.04,,,RGB(YELLOW),RGB(YELLOW)
end sub
'	
'Subroutines to make the compass pointer move to the correct position thanks to Matherp
sub moveto(angle1 as integer)
local integer xs=x, ys=y, ws=w, hs=h
rotatetriangle(angle,0,radius,x0,y0,x1,y1,x2,y2)
pxx0=xx0+pivot_x
pyy0=yy0+pivot_y-radius
pxx1=xx1+pivot_x
pyy1=yy1+pivot_y-radius
pxx2=xx2+pivot_x
pyy2=yy2+pivot_y-radius
getlimits(x, y, w, h)
' blit write and blit close first time in will error so skip
ON ERROR SKIP 2
BLIT WRITE #1, xs, ys 'restore the save background
blit close #1
blit read #1, x, y, w, h
triangle pxx0, pyy0, pxx1, pyy1, pxx2, pyy2, RGB(BLUE),RGB(BLUE) 'COLOUR OF TRIANGLE
END sub
'
sub getlimits(x as integer, y as integer, w as integer, h as integer)
Local integer i,max_x=0,min_x=MM.HRES,max_y=0,min_y=MM.VRES
IF(pxx0>max_x)THEN max_x=pxx0
IF(pxx1>max_x)THEN max_x=pxx1
IF(pxx2>max_x)THEN max_x=pxx2
IF(pxx0<min_x)THEN min_x=pxx0
IF(pxx1<min_x)THEN min_x=pxx1
IF(pxx2<min_x)THEN min_x=pxx2
IF(pyy0>max_y)THEN max_y=pyy0
IF(pyy1>max_y)THEN max_y=pyy1
IF(pyy2>max_y)THEN max_y=pyy2
IF(pyy0<min_y)THEN min_y=pyy0
IF(pyy1<min_y)THEN min_y=pyy1
IF(pyy2<min_y)THEN min_y=pyy2
x=min_x
y=min_y
w=max_x-min_x+2
h=max_y-min_y+2
END sub
'
' Simple trig to rotate the vertices of a triangle
' specIFied as x0,y0,x1,y1,x2,x2 relative to coordinate 0,0
' by the angle specIFied
' and THEN translate them about the supplied real centre x,y
' the calculated coordinates are THEN placed into element n of a set of coordinate arrays
'
sub rotatetriangle(angle as float, x as integer, y as integer, x0 as integer, y0 as integer, x1 as integer, y1 as integer, x2 as integer, y2 as integer)
local float sine=sin(rad(angle)),cosine=cos(rad(angle))
local integer x0a,y0a,x1a,y1a,x2a,y2a
x0a= x0*cosine - y0 * sine + x
y0a= y0*cosine + x0 * sine + y
x1a= x1*cosine - y1 * sine + x
y1a= y1*cosine + x1 * sine + y
x2a= x2*cosine - y2 * sine + x
y2a= y2*cosine + x2 * sine + y
xx0=x0a
yy0=y0a
xx1=x1a
yy1=y1a
xx2=x2a
yy2=y2a
END sub
'*******END of compss routine  *******************************
'	
' Interrupt Sub to display the clock
Sub UpDateTime ' called by 1 second interrupt from SetTick
Text MM.HRES/2-40,MM.VRES/60, TIME$, LT,4, 1, RGB(WHITE),RGB(162, 160, 160 )   'display current time
END Sub
'
'*********************Functions***********************
' calculate the minutes since midnight 1st Jan 2014
Function GetMins(yr, mth, day, hr, min)
GetMins = (yr - 14) * (365 * 24 * 60) + ((yr - 13) \ 4) * (24 * 60)
GetMins = GetMins + (md(mth) * (24 * 60))
GetMins = GetMins + ((day - 1) * (24 * 60))
GetMins = GetMins + (hr * 60)
GetMins = GetMins + min
IF (yr - 16) Mod 4 = 0 And mth > 2 THEN GetMins = GetMins + (24 * 60)
END Function

' convert minutes back into the time (as a string)
Function GetTime$(minutes)
Local hr, min, am$
am$ = "AM"
hr = (minutes \ 60) Mod 24
'IF hr > 12 THEN am$ = "PM" : hr = hr - 12
'IF hr = 0 THEN hr = 12
min = minutes Mod 60
GetTime$ = Str$(hr) + ":"
GetTime$ = GetTime$ + Right$("0" + Str$(min), 2) + ":"
GetTime$ = GetTime$ + Right$("0" + Str$(sec), 2) + " " '  + am$
GetTime$=" " + GetTime$
END Function
'
'******Function to convert UnixTime to Normal Time******
Function HumanTime(UT As Integer,opt As Integer) As String
' take seconds since 1970-01-01 (unixtime) and converts to a human form date/time as
' IF opt=0 (or not specIFied) the format is dd-mm-yyyy hh:mm:ss" to match the format of DATE$
' IF opt<>0 the date part is returned as yyyy-mm-dd to aid sorting and avoid
Local integer d,m,s,y,z
IF UT<0 THEN HumanTime$="":Exit Function
y=1970:d=UT\86400:s=UT Mod 86400
Do
  z=365+IsLeapYear(y)
  IF d>=z THEN
    d=d-z:y=y+1
  Else
    Exit Do
  END IF
Loop
'here, Y is the current year and d the remaining days
m=1' start at january
' days between the start of the year and the current month
Do
  z=0
  Select Case m
    Case 1,3,5,7,8,10
      IF d>=31 THEN d=d-31:z=1
    Case 2
      IF IsLeapYear(y)THEN
        IF d>=29 THEN d=d-29:z=1
      Else
        IF d>=28 THEN d=d-28:z=1
      END IF
    Case 4,6,9,11
      IF d>=30 THEN d=d-30:z=1
  END Select
  IF z=1 THEN
    m=m+1
  Else
    d=d+1:Exit Do 'first day is 1 not 0
  END IF
Loop
IF opt<>0 THEN
  HumanTime$=Str$(y)+"-"+ZPad$(m,2)+"-"+ZPad$(d,2)
Else
  HumanTime$=ZPad$(d,2)+"-"+ZPad$(m,2)+"-"+Str$(y)
END IF
y=s\3600:s=s-y*3600
m=s\60:s=s-m*60
HumanTime$=HumanTime$+" "+ZPad$(y,2)+":"+ZPad$(m,2)+":"+ZPad$(s,2)
END Function

Function IsLeapYear(n As Integer) As Integer
IsLeapYear=((n Mod 4=0) And (n Mod 100 <>0)) Or (n Mod 400=0) 		
End Function

Function ZPad$(x As integer,y As integer)
'adds y leading zeroes to X
ZPad$=Right$(String$(y,"0")+Str$(x),y)
End Function

function DayOfWeek(year, month, day)
local a,m,y
a = int((14-month)/12)
m = month + 12*a - 2
y = year - a
DayOfWeek = (day + y + int(y/4)-int(y/100)+int(y/400)+int(31*m/12)) mod 7
END function

'-----------------------------------------
' Computes the number of Julian days elapsed since 2000-01-01 12:00 UTC for
' date d$ and time t$ (leave the latter empty to get the elapsed time in full
' days). Note: t$ is the local time (the time zone is subtracted from it).
FUNCTION JD2000(d$,t$)
LOCAL FLOAT jd
LOCAL INTEGER day,month,year,hour,min,sec
day=VAL(LEFT$(d$,2)):month=VAL(MID$(d$,4,2)):year=VAL(RIGHT$(d$,4))-2000
jd=365*year+(year+3)\4+275*month\9-((month+9)\12)*(1+((year MOD 4)+2)\3)+day-31
IF LEN(t$)=8 THEN
  hour=VAL(LEFT$(t$,2))-tz:min=VAL(MID$(t$,4,2)):sec=VAL(RIGHT$(t$,4))
  jd=jd+hour/24.0+min/1440.0+sec/3600.0
ENDIF
JD2000=jd
END FUNCTION
